package webhandlers

import (
	"fmt"
	"net/http"

	"git.agecem.com/agecem/bottin/v4/data"
	"github.com/labstack/echo/v4"
	"github.com/spf13/viper"
)

func GetIndex(c echo.Context) error {
	return c.Render(http.StatusOK, "index-html", nil)
}

func GetMembre(c echo.Context) error {
	apiClientKey := viper.GetString("web.api.key")
	apiClientHost := viper.GetString("web.api.host")
	apiClientProtocol := viper.GetString("web.api.protocol")
	apiClientPort := viper.GetInt("web.api.port")

	/*
		log.Printf(`
		    apiClientKey: %s
		    apiClientHost: %s
		    apiClientProtocol: %s
		    apiClientPort: %d`,
			apiClientKey, apiClientHost, apiClientProtocol, apiClientPort,
		)
	*/

	apiClient := data.NewApiClient(apiClientKey, apiClientHost, apiClientProtocol, apiClientPort)

	membreID := c.QueryParam("membre_id")

	/*
		// TODO
		log.Printf("Requesting membreID: [%s]", membreID)
	*/

	membre, err := apiClient.GetMembre(membreID)
	if err != nil {
		return c.Render(http.StatusBadRequest, "index-html", struct {
			Result string
		}{
			Result: fmt.Sprintln("👎", err.Error()),
		})
	}

	membreResult := fmt.Sprintf(`👍 
    Membre trouvéE: [%s]`, membre.ID)

	if membre.PreferedName != "" {
		membreResult = fmt.Sprintf("%s    -> %s", membreResult, membre.PreferedName)
	} else {
		membreResult = fmt.Sprintf("%s    -> %s, %s", membreResult, membre.LastName, membre.FirstName)
	}

	return c.Render(http.StatusOK, "index-html", struct {
		Result string
	}{
		Result: membreResult,
	})
}
